/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is mozCmgui.
 *
 * The Initial Developer of the Original Code is
 * Auckland Uniservices Ltd, Auckland, New Zealand.
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
#include "TextureZincXpidl.hpp"
#include "nsMemory.h"
extern "C" {
#include "api/cmiss_core.h"
#include "api/cmiss_texture.h"
}

CmguiTexture::CmguiTexture()
{
  /* constructor code */
}

CmguiTexture::~CmguiTexture()
{
  /* destructor code */
}

/* [noscript] void set_pixels (in unsigned long width, in unsigned long height, in unsigned long depth, in unsigned long number_of_components, in unsigned long number_of_bytes_per_component, in unsigned long source_width_bytes, in voidPtr source_pixels); */
NS_IMETHODIMP CmguiTexture::SetPixels(PRUint32 width, PRUint32 height, PRUint32 depth, PRUint32 number_of_components, PRUint32 number_of_bytes_per_component, PRUint32 source_width_bytes, void * source_pixels)
{
	if (!(Cmiss_texture_set_pixels(impl, width, height, depth, number_of_components, number_of_bytes_per_component, source_width_bytes, (unsigned char *)source_pixels)))
  {
    return NS_ERROR_UNEXPECTED;
  }
  return NS_OK;
}

/* [noscript] void get_pixels(in unsigned long left, in unsigned long bottom, in unsigned long depth_start, in long width, in long height, in long depth, in unsigned long padded_width_bytes, in unsigned long number_of_fill_bytes, in voidPtr fill_bytes, in unsigned long components, in voidPtr destination_pixels); */
NS_IMETHODIMP CmguiTexture::GetPixels(PRUint32 left, PRUint32 bottom, PRUint32 depth_start, PRInt32 width, PRInt32 height, PRInt32 depth, PRUint32 padded_width_bytes, PRUint32 number_of_fill_bytes, void * fill_bytes, PRUint32 components, void * destination_pixels)
{
	if (!(Cmiss_texture_get_pixels(impl, left, bottom, depth_start, width, height, depth, padded_width_bytes, number_of_fill_bytes, (unsigned char *)fill_bytes, components, (unsigned char *)destination_pixels)))
  {
    return NS_ERROR_UNEXPECTED;
  }
  return NS_OK;
}
