
function zincWritePreference(key, value) {
   var preferencesService = 
		Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefService);
   var preferenceBranch = preferencesService.getBranch("zinc."); 

   try
	{
     preferenceBranch.setCharPref(key, value);
   } 
   catch (err)
	{
     dump("\nFailed to write preference key: " + key + " (" + value + ") : " + err + "\n");
   }
   try
	{
		preferencesService.savePrefFile(null);
   }
   catch (err)
	{
		dump("\nUnable to save preferences file: " + err + "\n");
   }
}


function zincReadPreference(key, fallbackValue)
{
   var preferencesService = 
		Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefService);
   var preferenceBranch = preferencesService.getBranch("zinc."); 

   var value;
   try
	{
     value = preferenceBranch.getCharPref(key);
   } 
   catch (err)
	{
     value = fallbackValue; 
   }
   return value;
}


function zincShowWelcomePage()
{
   var zincPreferenceVersion = zincReadPreference('version', '0.0.0.0');
   var zincCurrentVersion = zincVersion(); 

	if (undefined == zincCurrentVersion)
	{
		return;
	}
	if (undefined == zincPreferenceVersion)
	{
		return;
	}
	if (zincPreferenceVersion != zincCurrentVersion)
	{
		var url = 'chrome://zinc/content/zincInstallPage.html';
		zincWritePreference('version', zincCurrentVersion);
		var newTab = window.getBrowser().addTab(url);
		window.getBrowser().selectedTab = newTab;
		window.getBrowser().addTab('http://www.cmiss.org/cmgui/zinc/Install')
	}
}

function zincInitBrowserOverlay()
{
   setTimeout(function() { zincShowWelcomePage() }, 500);
}

addEventListener("load", zincInitBrowserOverlay, false);
